local cookies = require"cgilua.cookies"

function pt (tab)
	tab = tab or {}
	for i, v in pairs (tab) do
		local vv = v
		if type(v) == "table" then
			vv = ""
			for _i, _v in pairs (v) do
				vv = vv..string.format ("%s = %q, ", _i, _v)
			end
			vv = '{'..vv..'}'
		end
		cgilua.put (string.format ("%s = %s<br>\n", tostring (i), tostring (vv)))
	end
end

cgilua.htmlheader()
if cgilua.session then
	local SESSION_COOKIE_ID = "SESSION_ID"
	local sess_cook = cookies.get (SESSION_COOKIE_ID)
	
	if (cgi.field and sess_cook) then
		cgilua.put "cgi data{"
		pt(cgi)
		cgilua.put "}"
		cgilua.session.set(sess_cook,cgi)
		cgilua.put "<br>"
	end

	if not sess_cook or not cgilua.session.get(sess_cook) then
		cookies.set (SESSION_COOKIE_ID, cgilua.session.new())

		cgilua.put [[<form action="]]
		cgilua.put (cgilua.mkurlpath"test_session.lua")
		cgilua.put [[" method="POST">
  field: <input type="text" name="field" value="]]
	cgilua.put ("")
	cgilua.put [["><br>
  <input type="submit"><br>
</form>]]
	else 
		cgilua.put ("cgilua.session.data["..sess_cook.."] = {<br>\n")
		pt (cgilua.session.get(sess_cook))
		cgilua.put "}<br>\n"
	end
else
	cgilua.put "Sessions library is not available or not well configured"
end

